org.apache.xerces.xni.grammars

## Interface XMLGrammarPool

-     public interface XMLGrammarPool

  This interface specifies how the parser and the application interact with respect to Grammar objects that the application possesses--either by having precompiled them or by having stored them from a previous validation of an instance document. It makes no assumptions about the kind of Grammar involved, or about how the application's storage mechanism works.

  The interaction works as follows:

  - When a validator considers a document, it is expected to request grammars of the type it can handle from this object using the `retrieveInitialGrammarSet` method.
  - If it requires a grammar not in this set, it will request it from this Object using the `retrieveGrammar` method.
  - After successfully validating an instance, the validator should make any new grammars it has compiled available to this object using the `cacheGrammars` method; for ease of implementation it may make other Grammars it holds references to as well (i.e., it may return some grammars that were retrieved from the GrammarPool in earlier operations).
  Version:
    $Id: XMLGrammarPool.java 447245 2006-09-18 05:22:10Z mrglavas $
  Author:
    Neil Graham, IBM

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cacheGrammars(java.lang.String grammarType, Grammar[] grammars)` return the final set of grammars that the validator ended up with.
    `void` | `clear()` Removes all grammars from the pool.
    `void` | `lockPool()` Causes the XMLGrammarPool not to store any grammars when the cacheGrammars(String, Grammar[[]) method is called.
    `Grammar` | `retrieveGrammar(XMLGrammarDescription desc)` This method requests that the application retrieve a grammar corresponding to the given GrammarIdentifier from its cache.
    `Grammar[]` | `retrieveInitialGrammarSet(java.lang.String grammarType)` retrieve the initial known set of grammars.
    `void` | `unlockPool()` Allows the XMLGrammarPool to store grammars when its cacheGrammars(String, Grammar[]) method is called.

- - ### Method Detail

    - #### retrieveInitialGrammarSet

          Grammar[] retrieveInitialGrammarSet(java.lang.String grammarType)

      retrieve the initial known set of grammars. this method is called by a validator before the validation starts. the application can provide an initial set of grammars available to the current validation attempt.

      Parameters:
        `grammarType` - the type of the grammar, from the `org.apache.xerces.xni.grammars.Grammar` interface.
      Returns:
        the set of grammars the validator may put in its "bucket"

    - #### cacheGrammars

          void cacheGrammars(java.lang.String grammarType,
                           Grammar[] grammars)

      return the final set of grammars that the validator ended up with. This method is called after the validation finishes. The application may then choose to cache some of the returned grammars.

      Parameters:
        `grammarType` - the type of the grammars being returned;
        `grammars` - an array containing the set of grammars being returned; order is not significant.

    - #### retrieveGrammar

          Grammar retrieveGrammar(XMLGrammarDescription desc)

      This method requests that the application retrieve a grammar corresponding to the given GrammarIdentifier from its cache. If it cannot do so it must return null; the parser will then call the EntityResolver. An application must not call its EntityResolver itself from this method; this may result in infinite recursions.

      Parameters:
        `desc` - The description of the Grammar being requested.
      Returns:
        the Grammar corresponding to this description or null if no such Grammar is known.

    - #### lockPool

          void lockPool()

      Causes the XMLGrammarPool not to store any grammars when the cacheGrammars(String, Grammar[[]) method is called.

    - #### unlockPool

          void unlockPool()

      Allows the XMLGrammarPool to store grammars when its cacheGrammars(String, Grammar[]) method is called. This is the default state of the object.

    - #### clear

          void clear()

      Removes all grammars from the pool.

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.